/*
===============================================================================
Novell Software Developer Kit Sample Code License

Copyright (C) 2005, Novell, Inc.  All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
  *  Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  *  Redistributions in binary form must reproduce the above
     copyright notice, this list of conditions and the following
     disclaimer in the documentation and/or other materials provided
     with the distribution.
  *  Neither the name of Novell, Inc. nor the names of its contributors
     may be used to endorse or promote products derived from this
     software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT
SHALL NOVELL, INC., THE COPYRIGHT OWNER, OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

NAME OF FILE:
	nbkmsg.c

PURPOSE/COMMENTS:
	File containg error messages

NDK COMPONENT NAME AND VERSION:
	SMS Developer Components

LAST MODIFIED DATE: 
	18 October 2005

===============================================================================
*/
#include<nbkmsg.mlh>

#define gettext_noop(mesg) mesg

char *NbkMessages[]=
{
	gettext_noop("print this help"),
	gettext_noop("create a new archive"),
	gettext_noop("extract files from the archive"),
	gettext_noop("list files in the archive"),
	gettext_noop("name of the file/device that should contain the archive data"),
	gettext_noop("Option \'c\' or \'x\' requires a username to connect to Target Service Agent.\n"),
	gettext_noop("Example"),
	gettext_noop("exclude the file/directory with the specified path. use this option  multiple times to exclude more than one path"),
	gettext_noop("exclude all files matching the name or pattern. file name can contain a pattern with wild cards '*' and '?'. use this option multiple times to exclude more than one  pattern"),
	gettext_noop("restore by replacing <srcpath> with <destpath>"),
	gettext_noop("do not overwrite existing files during a restore operation. files will be overwritten, if this option is not present "),
	gettext_noop("connects to the specified host for backup"),
	gettext_noop("user name to connect to the Target Service Agent"),
	gettext_noop("password to connect to the Target service Agent"),
	gettext_noop("print statistical information"),
	gettext_noop("enable verbose messages"),
	gettext_noop("print version of the utility"),
	gettext_noop("Usage"),
	"Type",
	"TRUE",
	"FALSE",
	"Value",
	"Range",
	"switch",
	"Boolean",
	"StartupOnly",
	"Informational",
	gettext_noop("error allocating memory"),
	gettext_noop("failed to initialize"),
	"Cannot Delete This Data Set",
	"Cannot Rename This Data Set",
	"Unloading at this time may result in an abend\n",
	"connect to Target Service Agent failed with error %x\n",
	gettext_noop("Failed to open target. retrying...\n"),
	"error %x occurred in UTF-8 conversion \n",
	"Fail over / Fail back...\n",
	gettext_noop("reconnecting...\n"),
	gettext_noop("Reconnecting failed.\n"),
	"error saving session information\n",
	"failed to get the name in namespace %x\n",
	"failed to get name space type information with error %x\n",
	"failed to update name list: %x\n",
	gettext_noop("File name can not be found\n"),
	gettext_noop("Failed to open file %s"),
	gettext_noop("The value passed to the option '%s' is out of range\n"),
	gettext_noop("The option '%s' requires argument(s)\n"),
	gettext_noop("The option '%s' is not a valid option\n"),
	gettext_noop("The option '%s' takes no argument\n"),
	gettext_noop("The option '%s' is a load time option and cannot be used at run time"),
	gettext_noop("The option '%s' is a run time option and cannot be used at load time"),
	gettext_noop("Errors in the command line options"),
	gettext_noop("nbackup version %1$d.%2$2d"),
	gettext_noop("Invalid options\n"),
	gettext_noop("Command line must contain one of the \'-ctx\' options \n"),
	gettext_noop("Command line must not contain more than one of the \'-ctx\' options\n"),
	gettext_noop("Failed to connect to  Target Service Agent %1$s with error %2$x"),
	gettext_noop("Connecting to Target Service Agent %s"),
	gettext_noop("User name: "),
	gettext_noop("Password: "),
	gettext_noop("Connection denied\n"),
	gettext_noop("No files specified for backup"),
	gettext_noop("Unsupported operation"),
	gettext_noop("Unknown operation"),
	gettext_noop("\nNumber of resources scanned: %u"),
	gettext_noop("\nNumber of directories: %u"),
	gettext_noop("\nNumber of files: %u"),
	gettext_noop("\nTotal data size: %.2f KB"),
	gettext_noop("\nElapsed time:  %.2f minutes\n"),
	gettext_noop("\nThroughput:    %.2f MB/min\n"),
	gettext_noop("Error while reading from archive\n"),
	"unable to write dataset header or error in flushing transfer buffer",
	"error in flushing transfer buffer",
	gettext_noop("nbackup is a Novell backup application to backup and restore using the Novell Storage Management Services framework\n"),
	gettext_noop("nbackup [options] [directory1 ...directoryN] [file1 ...fileN] \n"),
	gettext_noop("No paths specified for creating archive\n"),
	gettext_noop("Option 'x' or 't' requires the archive name\n"),
	"\n\r\t primaryDataStreamSize= %d",
	"\n\r\t totalStreamsDataSize = %d",
	" Open ",
	"Read",
	" Close",
	"\n\rClose parent\n\r",
	"\n\rCreate parent",
	"mode=0x%x\n\r",
	"\n\rOpen child /w parent handle",
	"\n\rOpen parent, parent handle not used",
	"\n\rOpen child w/o parent handle",
	" Valid",
	" Excluded ",
	" Exists   ",
	"\n\r\tSystem Modify Bit Set\n",
	"\n\r\tSystem Modify Bit Reset\n",
	gettext_noop("Error while closing the data file"),
	"error while processing the transfer buffer",
	gettext_noop("Failed to open dataset %s for backup"),
	gettext_noop("Invalid path %s"),
	gettext_noop("nbackup -cvf myarchive.sidf -U userid /home/mypath"),
	gettext_noop("use file containing fully qualified paths as input for creating archive. this file should contain one path per line"),
	gettext_noop("perform incremental backup based on the last modified time"),
	gettext_noop("store full path instead of parent and terminal node"),
	gettext_noop("restore the archive to the given directory path. this will append the path in the archive with the given path"),
	gettext_noop("Invalid file specified for -T option"),
	gettext_noop("Invalid date format"),
	gettext_noop("Option multiply specified"),
	gettext_noop("Error in specifying rename restore options\n"),
	gettext_noop("Failed to read dataset %s for backup"),
	gettext_noop("Unable to retrieve the Target Service Name list from %s"),
	gettext_noop("Error while writing to archive"),
	gettext_noop("connects to the Target Service of the specified Target type"),
	gettext_noop("append a file/directory to an existing SIDF archive"),
	gettext_noop("extract the file/directory with the specified path. use this option multiple times to extract more than one path"),
	gettext_noop("extract all files matching the name or pattern. file name can contain a pattern with wild cards '*' and '?'. use this option multiple times to extract more than one  pattern"),
	gettext_noop("This does not look like a nbackup archive"),
	gettext_noop("associate label with an archive "),
	gettext_noop("\nSession Name: <none>\n"),
	gettext_noop("\nSession Name: %s\n"),
	gettext_noop("\nThis operation has resulted in errors. Please see %s file for details\n"),
	gettext_noop("Internal error"),
	gettext_noop("Unable to process name information"),
	gettext_noop("Try 'nbackup --help' for more options"),
	gettext_noop("exclude file data during backup or restore"),
	gettext_noop("Failed to complete the backup as this path may have more than 255 separators"),
	gettext_noop("Skipped this path as it may have more than 255 separators"),
	gettext_noop("\nInsert volume #%1$d for Session %2$s and press return key"),
	gettext_noop("create/list/extract multi-volume archive"),
	gettext_noop("Option \'create\' with \'multi-volume\' requires label name\n"),
	gettext_noop("\nIncorrect volume, required volume #%1$d of Session %2$s"),
	gettext_noop("prompts for new tape after writing specified number of Kilo Bytes"),
	gettext_noop("Tape length should be more than 72 Kilo Bytes\n"),
	gettext_noop("use CASA token for authentication\n"),
	gettext_noop("Failed to obtain CASA token with error %d\n"),
	gettext_noop("Directory backup requires -F option\n"),
	gettext_noop("Failed to initialize.Unable to locate CASA Auth Token Client libraries\n"),
	gettext_noop("Operation performed as user %s\n"),
	gettext_noop("exclude file/directory trustees during backup or restore")
	
};

